/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

//shopId = "58f30d46-0dab-4629-8712-0bc9db1b94ee"; // !! DEBUG


var items = new Array(); // サーチ結果を保持
var panoramas = new Array(); // パノラマのリスト
var panoramaNameTbl = new Object(); // パノラマId->パノラマ名変換テーブル
var layoutDone = false; // レイアウト済みフラグ
var panoVisitList = new Object(); // パノラマ訪問済みリスト
var itemDetailCheckList = new Object(); // アイテム詳細閲覧リスト

$(function(){
    panoramaSearch(); // パノラマリスト取得
   
    // loading表示
    $('span.loading').bind('ajaxStart', function() {
        $(this).show();
    }).bind('ajaxStop', function() {
        $(this).hide();
    });
    
    // アイテム検索ボタンを押したとき
    $("#searchItemButton").click(function(){
        if ($("#searchBoxContainer").is(":hidden")) {
            showSearchBox();
        }
        else {
            hideSearchBox();
        }
        hideItemDetail(); // とりあえずアイテム詳細ポップアップは閉じる
        hideSearchResultList(); // とりあえず検索結果ウインドウは閉じる
    });
    
    // エリア選択ボタンを押したとき
    $("#selectAreaButton").click(function(){
        showPanoramaList();
        hideSearchBox(); // とりあえず検索窓は閉じる
        hideItemDetail(); // とりあえずアイテム詳細ポップアップは閉じる
        hideSearchResultList(); // とりあえず検索結果ウインドウは閉じる
    });
    
    // エリア選択クローズボタンを押したとき
    $("#panoramaListCloseBtn").click(function(){
        hidePanoramaList();
    });
    
    // マップボタンを押したとき
    $("#mapButton").click(function(){
        showMap();
    });
    
    // ヘルプボタンを押したとき
    $("#helpButton").click(function(){
        toggleIpadMotionControl();
    });
    
    // インクリメンタルサーチ
    $('#searchBox').bind('textchange', function() {
//        console.log("searchword=" + $(this).val());
        itemSearch($(this).val(), null);
    });    

});

 function GetFileName(file_url){
    file_url = file_url.substring(file_url.lastIndexOf("/")+1,file_url.length)
    //拡張子も取り除く場合は次の行のコメントアウトをはずしてください
    file_url = file_url.substring(0,file_url.indexOf("."));
    return file_url;
}

// 商品検索
function itemSearch(query, panoId) {
//    var url = "http://localhost:81/ItemSearch.aspx?query=" + encodeURIComponent(query)+ "&shopid=" + shopId;
    var url = "http://cloud.panoplaza.com/ItemSearch.aspx?query=" + encodeURIComponent(query)+ "&shopid=" + shopId;
    if (panoId != null) {
        url += "&panoramaid=" + panoId;
    }

    $.ajax({
        url: url,
        dataType: 'jsonp',
        success: function (data) {
//            console.log("result=" + data.items.length);
            makeSearchResultList(data);
            showSearchResultList();
        }
    });

    return false;
}

// パノラマ検索
function panoramaSearch() {
 //   var url = "http://localhost:81/PanoramaSearch.aspx?shopid=" + shopId + "&query=";
    var url = "http://cloud.panoplaza.com/PanoramaSearch.aspx?shopid=" + shopId + "&query=";

    $.ajax({
        url: url,
        dataType: 'jsonp',
        success: function (data) {
//            console.log("pano count=" + data.items.length);
            makePanoramaList(data);
            setHeaderInfo(); // ヘッダ情報表示          
            alignPanoramaList(); // パノラマリストの表示位置をセット
        }
    });

    return false;
}

// ヘッダに表示する内容をセットする
function setHeaderInfo()
{
    $("#shopname").html(shopName); // shopNameはindex.htmlのヘッダで定義
    
//    panoId = "a7923c10-68ff-4637-920d-00ec8ccadbc3"; // !! DEBUG
    $("#areaname").html(panoramaNameTbl[panoId]);
}

// スクリーンサイズ（ブラウザの表示領域）取得
function getScreenSize()
{
    var obj = new Object();
    obj.width = document.documentElement.clientWidth;
    obj.height = document.documentElement.clientHeight;
    
    return obj;
}

// ヘッダとフッターを表示する
function showHeaderFooter()
{
    if (layoutDone == true) {
        // 検索窓はクローズする
        hideSearchBox();
        return;
    }
    
    var size = getScreenSize();
      
    // header, footerの位置調整
    $("#header").css("width", size.width);
    $("#footer").css("width", size.width);
    $("#header").css("top", 0);
    $("#header").css("left", 0);
    $("#footer").css("top", size.height - $("#footer").height());
    $("#footer").css("left", 0);
    
    // areanameの位置調整
    var margin = 15;
    var leftpos = size.width - $("#areaname").width() - margin;
    $("#areaname").css("left", leftpos);
      
    // search itemボタンの位置調整
    leftpos = $("#selectAreaButton").width() + margin + 15;
    $("#searchItemButton").css("left", leftpos);
    
    // mapボタン、helpボタンの位置調整
    leftpos = size.width - $("#helpButton").width() - margin;
    $("#helpButton").css("left", leftpos);
    leftpos = size.width - $("#helpButton").width() - $("#mapButton").width() - margin * 2;
    $("#mapButton").css("left", leftpos);
      
    // フェードイン表示（単なる演出）
    $("#header").hide();
    $("#footer").hide();
    $("#header").fadeIn("slow");
    $("#footer").fadeIn("slow");
     
     layoutDone = true;
}

// 検索窓を表示する
function showSearchBox()
{
    var size = getScreenSize();
      
    // 表示位置調整
    $("#searchBoxContainer").css("top", 50);
    $("#searchBoxContainer").css("left", size.width / 2 - $("#searchBoxContainer").width() / 2);
      
    // フェードイン表示（単なる演出）
    $("#searchBoxContainer").hide();
    $("#searchBoxContainer").fadeIn("slow");
}

// 検索窓を非表示にする
function hideSearchBox()
{
     $("#searchBoxContainer").hide();   
}

// ショップ内のパノラマの一覧を取得しhtmlを作る
function makePanoramaList(data)
{
    panoramas.length = 0; // サーチ結果のリセット
    document.getElementById("panoramaList").innerHTML = ""; // htmlクリア

    for (var i = 0; i < data.items.length; i++) {
        panoramas[i] = data.items[i];

        // パノラマIdとパノラマ名の変換テーブルを作る
        panoramaNameTbl[data.items[i].panoramaId] = data.items[i].name;
               
        // html作成
        /*
        var html = "<div class='panoramaItem'>"
        + "<span class='panoramaItemCaption'>" + data.items[i].name + "</span>"
        + "</div>";
        */
        var html = "<div class='panoramaItem'>"
        + "<span class='panoramaItemCaption' panoid='" + data.items[i].panoramaId + "'>" + data.items[i].name + "</span>"
        + "</div>";
    
        document.getElementById("panoramaList").innerHTML += html;
    }

     // クリックしたときの挙動をセット
    $(".panoramaItem").click(function(){
        var itemno = $(".panoramaItem").index(this);
        expandSelectedPanorama(panoramas[itemno].panoramaId);
    });
}

// エリアリストを表示する
function showPanoramaList()
{    
    if ($("#panoramaListBoxContainer").is(":hidden")) {
        $("#panoramaListBoxContainer").slideDown("slow");
    }
    else
    {
        hidePanoramaList();
    }  
}

// エリアリストを非表示にする
function hidePanoramaList()
{
    $("#panoramaListBoxContainer").css("display", "none");
}

// エリアリストを表示する位置を決める
function alignPanoramaList()
{
     var size = getScreenSize();
      
    // 表示位置調整
    var margin = 10;
    var top = size.height - $("#panoramaListBoxContainer").height() - $("#footer").height() - margin;
  
    $("#panoramaListBoxContainer").css("top", top);
    $("#panoramaListBoxContainer").css("left", 10);   
       
    // 位置をセットしたら非表示にする
    $("#panoramaListBoxContainer").hide();
}

// エリアをクリックしたとき
function expandSelectedPanorama(panoId)
{
    itemSearch("", panoId);
}

// アイテム検索結果からhtmlを作る
function makeSearchResultList(data)
{
    items.length = 0; // サーチ結果のリセット
    document.getElementById("searchResultList").innerHTML = ""; // htmlクリア

    for (var i = 0; i < data.items.length; i++) {
        items[i] = data.items[i];

        var imgurl = data.items[i].imgurl;
        if (imgurl == null) { // リンク画像がない場合
            imgurl = "../../pvs/customize/startupasia/noimage.jpg";
        }
        
        // html作成
        /*
        var html = "<div class='searchResultItem'>"
        + "<img src='" + imgurl + "' class='searchResultItemThumb'/>"
        + "<span class='searchResultItemCaption'>" + data.items[i].name + "</span>"
        + "</div>";
        */
        var html = "";
        if (itemDetailCheckList[data.items[i].itemHotSpotId] == true) {
            html = "<div class='searchResultItem'>"
            + "<img src='" + imgurl + "' class='searchResultItemThumb'/>"
            + "<span class='searchResultSelectedItemCaption'>" + data.items[i].name + "</span>"
            + "</div>";                
        } else {
            html = "<div class='searchResultItem'>"
            + "<img src='" + imgurl + "' class='searchResultItemThumb'/>"
            + "<span class='searchResultItemCaption'>" + data.items[i].name + "</span>"
            + "</div>";            
        }

        document.getElementById("searchResultList").innerHTML += html;
    }

    // クリックしたときの挙動をセット
    $(".searchResultItem").click(function(){
        var itemno = $(".searchResultItem").index(this);
        moveToSelectedItem(items[itemno].panoramaId, items[itemno].x, items[itemno].y);
    });   
}

// 商品検索結果を表示する
function showSearchResultList()
{
    var size = getScreenSize();
        
    // 表示位置調整
    $("#searchResultBoxContainer").css("top", 100);
    $("#searchResultBoxContainer").css("left", size.width / 2 - $("#searchResultBoxContainer").width() / 2);
}

// 商品検索結果を非表示にする
function hideSearchResultList()
{
    $("#searchResultBoxContainer").css("top", "-9999px");
    $("#searchResultBoxContainer").css("left", "-9999px");

    // エリアリストも閉じる
    hidePanoramaList();
}

// 選択した商品へ視点移動する
function moveToSelectedItem(panoramaId, x, y)
{
    var krpano = document.getElementById("krpanoSWFObject");
    var currentPanoId = GetFileName(krpano.get("xml.url")); // 現在のパノラマ

    hideSearchResultList();
    hidePanoramaList();
    hideSearchBox();
    
    if (currentPanoId == panoramaId) // 同じパノラマ内のアイテム
    {
        krpano.call("lookto(" + x + "," + y + ");");
    }
    else // 別のパノラマ内のアイテム
    {
        var panoxml = panoramaId + ".xml";
        
//        panoxml = "panorama1.xml"; // !! DEBUG
        
        krpano.call("loadpano('" + panoxml + "',null,null,NOBLEND);");
        krpano.call("lookat(" + x + "," + y + ");");
    }
}

// マップ表示
function showMap()
{
    var krpano = document.getElementById("krpanoSWFObject");  
    krpano.call("action(zoommap_open);");
}

// パノラマ閲覧記録をつける
function updatePanoVisitList(id)
{
    panoVisitList[id] = true;
        
    // クラスを変更する
    $(".panoramaItemCaption[panoid=" + id + "]").addClass("panoramaSelectedItemCaption");
    $(".panoramaItemCaption[panoid=" + id + "]").removeClass("panoramaItemCaption");   
}

// アイテム詳細閲覧記録をつける
function updateItemDetailCheckList(id)
{
    itemDetailCheckList[id] = true;
}

// アイテム詳細ポップアップを閉じる(Flashのときのみ有効)
function hideItemDetail()
{
    var krpano = document.getElementById("krpanoSWFObject");  
    krpano.call("action(hideDetail);");
}

// パノラマIdを保持する
function setPanoramaId(id)
{
    panoId = id;
    
    setHeaderInfo(); // 新しいパノラマIdでヘッダ情報更新     
}

// 商品ポップアップ(html5）
function showItem_StartupAsia() 
{
    if( $("#myItem").length<=0 ){
        $("body").append("<div id='myItem'></div>");
    }
                
    if (productPrice == null) {
        productPrice = "---";
    }
    
    var title = truncate(productTitle, 30);
    
    var html = "<div id='myItemInner'>"                
    + "<div id='productDetailMain'>"
    + "<div id='productTitle'>" + title + "</div>"
    + "<div id='productImageContainer'>" 
    + "<img id='productImage' src='" + productImage + "' />"
    + "<span id='productPrice'>&yen; " + productPrice + "</span>"
    + "</div>"
    + "<div id='productDescription'>" + productDescription + "</div>"
    + "</div>"
    + "<div id='productDetailFooter'>"
    + "<a id='productDetailLink' href='" + productUrl + "' target='_blank'>more info.</a>"
    + "<div id='productDetailSNSbuttons'>"
    + "<img id='productDetailTwitterButton' src='../../pvs/customize/startupasia/icon_twitter.png' onclick='onTweet();'/>"
    + "</div>"
    + "</div>"
    + "</div>";
                                
    $("#myItem").html(html);
                
    tb_show("","#TB_inline?height=250&width=250&inlineId=myItem");
                
    // thickbox.cssをコードで書き換える
    $("#TB_window").css("width", "250px");
    $("#TB_window").css("height", "250px");    
    $("#TB_closeWindowButton").html("<img src='../../pvs/customize/startupasia/win_close.png' width='20px' />");                  
}

function toggleIpadMotionControl()
{
    if (ipadmotioncontrol_enabled != null) {
        ipadmotioncontrol_enabled = ipadmotioncontrol_enabled == true ? false : true;
        
        if (ipadmotioncontrol_enabled) {
            $("#helpButton").attr("src", "../../pvs/customize/startupasia/btn_help.or.png")
        }
        else {
            $("#helpButton").attr("src", "../../pvs/customize/startupasia/btn_help.png")            
        }
        
        var krpano = document.getElementById("krpanoSWFObject");
        var command = "set(hlookat_moveforce,0);set(vlookat_moveforce, 0);";   
        krpano.call(command);
    }
}